<?php
namespace Teknisa\PLA\Modules\Relatorio\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Pla00200RelacaoDeCardapios extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $birtStrategy; 

    public function __construct($reportService, $birtStrategy) {
        $this->birtStrategy = $birtStrategy;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    'pla00200' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00201' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00202' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00203' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'CDPICTPROD'     => 'P_CDPICTPROD',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00204' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'CDPICTPROD'     => 'P_CDPICTPROD',
                'NRORG'          => 'P_NRORG'
            ),
        ),
         'pla00210' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'CDPICTPROD'     => 'P_CDPICTPROD',
                'NRORG'          => 'P_NRORG'
            ),
        ),
         'pla00211' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'CDGRUPFILI'     => 'P_CDGRUPFILI',
                'LISTAFILIAL'    => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'LISTASERV'      => 'P_CDSERVICO',
                'IDSERVPRINC'    => 'P_IDSERVPRINC',
                'CDPICTPROD'     => 'P_CDPICTPROD',
                'NRORG'          => 'P_NRORG'
            ),
        ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();

        if(empty($row['CDGRUPFILI'])) {
            $row['CDGRUPFILI'] = null;
        }
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
}